/*
 * File:   __GP30W_GP30_APP_H
 * Author:
 *
 * Created on2015-5-18
 */

#ifndef __UWater_GP22_APP_H
#define	__UWater_GP22_APP_H

#include "type.h"
#include "UWater_gp22_driver.h"
#include "UWater_TemperatureCalculate_app.h"

#include <string.h>
 
/*--------------------------------- Variable Define ------------------------------------*/
/*************************궨****************************/
#define REAL_XTAL_CLOCK   4000000 //ڼ㾫ȷ1USʱʱƵ
#define TEST_ALARMA_RTCC_US  (FACTOR_1*1000000) //״̬ʱ
#define CALCULATED_COEFFICIENT     (STM32_SYSCLK/REAL_XTAL_CLOCK)
#define ALARMA_STOP_CHECK_TICKS    ((TEST_ALARMA_RTCC_US + 100000)*CALCULATED_COEFFICIENT) //ľȷʱ


/*************************RAMλ궨****************************/
#define GP30_COPY_RESET_TEST_FLAG 0x5A6B7C8D //λǰıƴڼ춨״̬
#define GP30_COPY_RESET_NORMAL_FLAG 0x8D7C6B5A //λǰıƴڷǼ춨״̬
#define MCU_RESET_JUDGE_FLAG  0x3A4B5C6D //ǷΪλı־

/*************************ʱ0У׼־궨****************************/
#define DIFTOF_CALIBRATION_FLAG 0xA1B2C3D4E5F6A7B8 //У׼־
//#define DIFTOF_HIGH_TEMP_CALIBRATION_VALUE 0x189//У׼£ʱݲԽȥ1500ps
//#define DIFTOF_HIGH_TEMP_CALIBRATION_VALUE_FLOAT (float)0.006 //У׼ʱʱ1500ps0.006=1.5ns/250¶ȴ35ʱٵ1500ps
//#define DIFTOF_HIGH_TEMP_START_FLOW_COMPENSATE 0x106//У׼£30ʼ1000ps0x106=262=1*65536/250
//#define DIFTOF_LOW_TEMP_START_FLOW_COMPENSATE  0xB7//У׼£30ȼ30ʼ700ps0xB8=184=0.7*65536/250
#define DIFTOF_CALIBRATION_CNT 41400//ÿۼ23СʱˮΪҪУ׼41400=3600*23/2
#define DIFTOF_CALIBRATION_MIN (float)-0.04//10ns/250=0.04
#define DIFTOF_CALIBRATION_MAX (float)0.04
/************************ƿطжϲ****************************/
#define FLOAT_15NS              (float)0.06//15nsʱӦ˲ʱfloatֵ=15/250
#define FLOAT_2NS              (float)0.04//10nsʱӦ˲ʱfloatֵ=10/250
#define TOF_UP_AM                 150//upƽֵ
#define TOF_DOWN_AM               150//downƽֵ

#define UP_AM_MAX   600
#define DOWN_AM_MAX   600


#if  DN15_BRASS_40KPA_GP30_32768  ||  WDFS_DN15_BRASS_40KPA_GP30_32768                         //
#define FRAME_FIRST_POWER_FLG   0x16  
#define FRAME_CALIBER           0x15    
#define FM_METER_TYPE       	0x04			//DN15 40Kpa 04
#define GP30_APP_DNX        0X15

#elif   LLGS_DN15_BRASS_40KPA_GP30_32768 || LLGS_WDFS_DN15_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x16 //޸  
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x10			//BM_DN15 63Kpa 16
#define GP30_APP_DNX        0X15

#elif   ROUND_LLGS_DN15_BRASS_40KPA_GP30_32768 || ROUND_LLGS_WDFS_DN15_BRASS_40KPA_GP30_32768 || Buxiugang_LLGS_WDFS_DN15_BXG_40KPA_GP30_32768 || Plastic_LLGS_WDFS_DN15_PALSTIC_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x16  
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x1A			//ԲǱ  26
#define GP30_APP_DNX        0X15

#elif   ROUND_LLGS_XFZ_DN15_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x16  
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x1A			//ԲǱ  28
#define GP30_APP_DNX        0X15

//20211204
#elif   PF_DN15_BRASS_63KPA_GP30_32768 
#define FRAME_FIRST_POWER_FLG   0x16   
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x13			//  19
#define GP30_APP_DNX        0X15

#elif   BM_DN15_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x16  
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x01			//BM_DN15 63Kpa 01
#define GP30_APP_DNX        0X15

#elif   MID_DN15_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x16  
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x07			//DN15 63Kpa 07
#define GP30_APP_DNX        0X15

#elif	EN_DN15_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x16  
#define FRAME_CALIBER           0x15 
#define FM_METER_TYPE       	0x0E			//DN15 63Kpa 14
#define GP30_APP_DNX        0X15

#elif   DN20_BRASS_40KPA_GP30_32768 ||  WDFS_DN20_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x05			//DN20 40Kpa 05
#define GP30_APP_DNX        0X20

#elif   BM_DN20_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x02			//BM_DN20 40Kpa 02
#define GP30_APP_DNX        0X20

#elif   MID_DN20_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x08			//DN20 63Kpa 08
#define GP30_APP_DNX        0X20

#elif   EN_DN20_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x0F			//BM_DN20 40Kpa 0F
#define GP30_APP_DNX        0X20

#elif   LLGS_DN20_BRASS_40KPA_GP30_32768 || LLGS_WDFS_DN20_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x11			//LLGS_DN20 40Kpa 17
#define GP30_APP_DNX        0X20

#elif   ROUND_LLGS_DN20_BRASS_40KPA_GP30_32768 || ROUND_LLGS_WDFS_DN20_BRASS_40KPA_GP30_32768 || Buxiugang_LLGS_WDFS_DN20_BXG_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x1B			//ԲǱ  27
#define GP30_APP_DNX        0X20

#elif ROUND_LLGS_XFZ_DN20_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x1D			//ԲǱ  29
#define GP30_APP_DNX        0X20

//20211205
#elif   PF_DN20_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x20  
#define FRAME_CALIBER           0x14 
#define FM_METER_TYPE       	0x14			//PF_DN20_BRASS_63KPA_GP30_32768 20
#define GP30_APP_DNX        0X20

#elif DN25_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x25  
#define FRAME_CALIBER           0x25 
#define FM_METER_TYPE       	0x09			//DN25 40Kpa 09
#define GP30_APP_DNX        0X25

#elif BM_DN25_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x25  
#define FRAME_CALIBER           0x25 
#define FM_METER_TYPE       	0x03			//DN25 63Kpa 03
#define GP30_APP_DNX        0X25

#elif MID_DN25_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x25  
#define FRAME_CALIBER           0x25 
#define FM_METER_TYPE       	0x06			//DN25 63Kpa 06
#define GP30_APP_DNX        0X25

#elif LLGS_DN25_BRASS_40KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x25  
#define FRAME_CALIBER           0x25 
#define FM_METER_TYPE       	0x12			//DN25 40Kpa 18
#define GP30_APP_DNX        0X25
//20211205
#elif PF_DN25_BRASS_63KPA_GP30_32768
#define FRAME_FIRST_POWER_FLG   0x25  
#define FRAME_CALIBER           0x25 
#define FM_METER_TYPE       	0x15			//DN25 40Kpa 21
#define GP30_APP_DNX        0X25

#elif   DN32_BRASS_63KPA_GP30_32768	
#define FRAME_FIRST_POWER_FLG   0x32  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x16			//DN32 63Kpa 22
#define GP30_APP_DNX        0X32

#elif  BM_DN32_BRASS_63KPA_GP30_32768 
#define FRAME_FIRST_POWER_FLG   0x32  
#define FRAME_CALIBER           0x32 
#define FM_METER_TYPE       	0x0C			//DN32 63Kpa 0C
#define GP30_APP_DNX        0X32
//20211205
#elif  PF_DN32_BRASS_63KPA_GP30_32768 
#define FRAME_FIRST_POWER_FLG   0x32  
#define FRAME_CALIBER           0x20 
#define FM_METER_TYPE       	0x17			//DN32 63Kpa 23  //FM_METER_TYPEû
#define GP30_APP_DNX        0X32  

#elif  DN40_BRASS_63KPA_GP30_32768	
#define FRAME_FIRST_POWER_FLG   0x40  
#define FRAME_CALIBER           0x28 
#define FM_METER_TYPE       	0x19			//DN40 63Kpa 25
#define GP30_APP_DNX           0X40
#elif BM_DN40_BRASS_63KPA_GP30_32768 
#define FRAME_FIRST_POWER_FLG   0x40  
#define FRAME_CALIBER           0x40 
#define FM_METER_TYPE       	0x0D			//DN40 63Kpa 0D
#define GP30_APP_DNX        0X40

//20211205
#elif PF_DN40_BRASS_63KPA_GP30_32768 
#define FRAME_FIRST_POWER_FLG   0x40  
#define FRAME_CALIBER           0x28 
#define FM_METER_TYPE       	0x18			//DN40 63Kpa 24  //FM_METER_TYPEû
#define GP30_APP_DNX        0X40

#endif

#if		  DN15_BRASS_40KPA_GP30_32768 || WDFS_DN15_BRASS_40KPA_GP30_32768 || LLGS_DN15_BRASS_40KPA_GP30_32768 || LLGS_WDFS_DN15_BRASS_40KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN15ͭ40KPAʱʹֵ  700ns
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.185217176//  16L/hӦʱֵ2.96347
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              9
#define   SEGMENT_NUM_MIDDLE             25//2021-0703
#define   SEGMENT_NUM_LARGE              85	
#define   SEGMENT_NUM_ERROR_MIDDLE       (SEGMENT_NUM_LARGE/2)   //˴DN15ֵõͬһߣֻΪ˼4ΣΪ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)55909.72//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)82872.617//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)6.03335598778e-9//·ȵ
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)59.8//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)10.7   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)8.361204e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)335.9905  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631
    
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif ROUND_LLGS_DN15_BRASS_40KPA_GP30_32768 || ROUND_LLGS_WDFS_DN15_BRASS_40KPA_GP30_32768 
#define   DEFAULT_START_FLOW   0x00B7 //DN15ͭ40KPAʱʹֵ  700ns
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.185217176//  16L/hӦʱֵ2.96347
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              15
#define   SEGMENT_NUM_MIDDLE             43
#define   SEGMENT_NUM_LARGE              230

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ
 

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)57442.78//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)85145.007//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.8723349381e-9//·ȵ
#define   TOF_UP_DOWN_DAOSHUHE_LOW          (float)0.035591  //1/up + 1/down   35   
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.0359228//1/up + 1/down    35~45
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)62//
#define   MEASYRING_TUBE_DIAMETER             (float)11.5   //1511.5,  2012.5
#define   FLOW_RATE_MULTIPLIER				  (float)8.064516e-9 //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)373.92894 //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h  15ھ103.86915  20ھ122.71875
    
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif  Plastic_LLGS_WDFS_DN15_PALSTIC_40KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN15ͭ40KPAʱʹֵ  700ns
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.163410708 //  16L/hӦʱֵ2.677016788
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              13                // У׼ 6 10 16 80 2500
#define   SEGMENT_NUM_MIDDLE             26
#define   SEGMENT_NUM_LARGE              75

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                240 //190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)57442.78//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)85145.007//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.8723349381e-9//·ȵ
#define   TOF_UP_DOWN_DAOSHUHE_LOW          (float)0.035591  //1/up + 1/down   35   
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.0359228//1/up + 1/down    35~45
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)60//
#define   MEASYRING_TUBE_DIAMETER             (float)11.7   //1511.5,  2012.5
#define   FLOW_RATE_MULTIPLIER				  (float)8.33333e-9 //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)387.04826 //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h  15ھ103.86915  20ھ122.71875
    
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif Buxiugang_LLGS_WDFS_DN15_BXG_40KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN15ͭ40KPAʱʹֵ  700ns
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.189303125 //  16L/hӦʱֵ3.101189931
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              13
#define   SEGMENT_NUM_MIDDLE             26
#define   SEGMENT_NUM_LARGE              75
#define   SEGMENT_NUM_ERROR_MIDDLE       35 // 13~80 Ϊ2  13~40һΡ26~80һ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ
 

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)57442.78//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)85145.007//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.8723349381e-9//·ȵ
#define   TOF_UP_DOWN_DAOSHUHE_LOW          (float)0.035591  //1/up + 1/down   35   
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.0359228//1/up + 1/down    35~45
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)62//
#define   MEASYRING_TUBE_DIAMETER             (float)11.1   //1511.1,//
#define   FLOW_RATE_MULTIPLIER				  (float)8.064516e-9 //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)348.36888 //  㳣=  (3.1416*D*D*1(e-6)/4 )*3600 *1000L/h  15ھ103.86915  20ھ122.71875
    
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif ROUND_LLGS_XFZ_DN15_BRASS_40KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN15ͭ40KPAʱʹֵ  700ns
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.185217176//  16L/hӦʱֵ2.96347
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              15                // 10 16 28 100 2500
#define   SEGMENT_NUM_MIDDLE             28
#define   SEGMENT_NUM_LARGE              93

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ
 

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                240 //190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)57442.78//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)85145.007//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.8723349381e-9//·ȵ
#define   TOF_UP_DOWN_DAOSHUHE_LOW          (float)0.035591  //1/up + 1/down   35   
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.0359228//1/up + 1/down    35~45
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)62//
#define   MEASYRING_TUBE_DIAMETER             (float)11.5   //1511.5,  2012.5
#define   FLOW_RATE_MULTIPLIER				  (float)8.064516e-9 //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)373.92894 //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h  15ھ103.86915  20ھ122.71875
    
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1


#elif     MID_DN15_BRASS_63KPA_GP30_32768//ŷDN15ھ 2022-08-04
#define   DEFAULT_START_FLOW  0x00B7 //DN15ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.200274918// 
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              8
#define   SEGMENT_NUM_MIDDLE             25
#define   SEGMENT_NUM_LARGE              85
#define   SEGMENT_NUM_ERROR_MIDDLE       (SEGMENT_NUM_LARGE/2)   //˴DN15ֵõͬһߣֻΪ˼4ΣΪ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)59.8//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)10   
#define   FLOW_RATE_MULTIPLIER				  (float)8.361204e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)290.412  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // PF 15:80.67  PF 20134.95
	
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif	  EN_DN15_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW  0x00B7 //DN15ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.200274918// 
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              8
#define   SEGMENT_NUM_MIDDLE             25
#define   SEGMENT_NUM_LARGE              77
#define   SEGMENT_NUM_ERROR_MIDDLE       (SEGMENT_NUM_LARGE/2)   //˴DN15ֵõͬһߣֻΪ˼4ΣΪ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)59.8//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)10   
#define   FLOW_RATE_MULTIPLIER				  (float)8.361204e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)290.412  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // PF 15:80.67  PF 20134.95
	
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     BM_DN15_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW  0x00B7 //DN15ͭ63KPAʱʹֵ 700ps
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.207551802 //16L/hӦʱֵ 3.320828833
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              8
#define   SEGMENT_NUM_MIDDLE             25
#define   SEGMENT_NUM_LARGE              90

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1
#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1

//20211204
#elif	  PF_DN15_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW  0x00B7 //DN15ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.200274918// 
#define   R400Q1              (float)6.25
#define   R400Q2              (float)10
#define   R250Q2              (float)16
#define   Q3_3_3              (float)825
#define   Q3_6_6              (float)1650
#define   MIN_FLOW_0_6              0x50000//С50%
#define   MAX_FLOW_1_02             0xC730000//102%
#define   MIN_FLOW_0_3              0x30000//С30%
#define   LIMIT_FLOW_1_5Q4          4680//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              8
#define   SEGMENT_NUM_MIDDLE             25
#define   SEGMENT_NUM_LARGE              85
#define   SEGMENT_NUM_ERROR_MIDDLE       (SEGMENT_NUM_LARGE/2)   //˴DN15ֵõͬһߣֻΪ˼4ΣΪ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define FLOAT_BETWEEN_DATA_DIF_MAX    (float)3.8//950nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_SWITCH_STATE_THRESHOLD    (float)3.4//850nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_BETWEEN_DATA_DIF        	(float)2.2//550nsʱӦ˲ʱfloatֵ=550/250	  ֮Ĳֵ
#define FLOAT_LAST_DATA_MAX_THRESHOULD     	(float)1.4//350nsʱӦ˲ʱfloatֵ=350/250	  һݵжֵ    жжǸ-350
#define FLOAT_LAST_DATA_MIN_THRESHOULD      (float)1.84//460nsʱӦ˲ʱfloatֵ=460/250	  һݵжֵ    жжǸ-460
#define FLOAT_SWITCH_STATE_CURRENT_THRESHOLD        (float)0.64//160nsʱӦ˲ʱfloatֵ=160/250	  ٽ״̬ǰݵֵ
	
//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)59.8//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)10   
#define   FLOW_RATE_MULTIPLIER				  (float)8.361204e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)290.412  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // PF 15:80.67  PF 20134.95
	
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1


#elif     DN20_BRASS_40KPA_GP30_32768 || WDFS_DN20_BRASS_40KPA_GP30_32768 
#define   DEFAULT_START_FLOW  0x00D1 //DN20ͭ40KPAʱʹֵ
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.129817327// 25L/hӦʱֵ3.245433172
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              14
#define   SEGMENT_NUM_MIDDLE             34
#define   SEGMENT_NUM_LARGE              155

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)12.8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)57881.92//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)85795.925778//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.8277825603528e-9//·ȵ
    
#elif     LLGS_DN20_BRASS_40KPA_GP30_32768 || LLGS_WDFS_DN20_BRASS_40KPA_GP30_32768
#define   DEFAULT_START_FLOW  0x00D1 //DN20ͭ40KPAʱʹֵ
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.129817327// 25L/hӦʱֵ3.245433172
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              16
#define   SEGMENT_NUM_MIDDLE             25
#define   SEGMENT_NUM_LARGE              155
#define   SEGMENT_NUM_ERROR_MIDDLE       43   //Ϊ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ


//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)59.95//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)13.6   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)8.3402836e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)527.8716  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)12.8//0.8R250Q1ֵ

#define   TOF_UP_DATA                   (float)57881.92//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)85795.925778//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.8277825603528e-9//·ȵ

#elif ROUND_LLGS_DN20_BRASS_40KPA_GP30_32768 || ROUND_LLGS_WDFS_DN20_BRASS_40KPA_GP30_32768 
#define   DEFAULT_START_FLOW  0x00D1 //DN20ͭ40KPAʱʹֵ
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.129817327// 25L/hӦʱֵ3.245433172
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              15
#define   SEGMENT_NUM_MIDDLE             35
#define   SEGMENT_NUM_LARGE              190



#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)12.8//0.8R250Q1ֵ
    
#define   TOF_UP_DATA                   (float)60160.65//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)89173.591031//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.6070412e-9//·ȵ
    
#define   TOF_UP_DOWN_DAOSHUHE_LOW           (float)0.03397054  //1/up + 1/down    35
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.03428789 //1/up + 1/down    35~45

//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)62////
#define   MEASYRING_TUBE_DIAMETER             (float)12.5   //1511.5,  2012.5
#define   FLOW_RATE_MULTIPLIER				  (float)8.064516e-9 //    ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)441.7875 //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h    15ھ103.86915  20ھ122.71875
 
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif	 Buxiugang_LLGS_WDFS_DN20_BXG_40KPA_GP30_32768
#define   DEFAULT_START_FLOW  0x00B8 //DN20ͭ40KPAʱʹֵ
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.1131270// 25L/hӦʱֵ2.8281742
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              15
#define   SEGMENT_NUM_MIDDLE             33
#define   SEGMENT_NUM_LARGE              130
#define   SEGMENT_NUM_ERROR_MIDDLE       47   //Ϊ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          170 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)12.8//0.8R250Q1ֵ
    
#define   TOF_UP_DATA                   (float)60160.65//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)89173.591031//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.6070412e-9//·ȵ
    
#define   TOF_UP_DOWN_DAOSHUHE_LOW           (float)0.03397054  //1/up + 1/down    35
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.03428789 //1/up + 1/down    35~45

//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)62////
#define   MEASYRING_TUBE_DIAMETER             (float)14   //1511.5,  2012.5
#define   FLOW_RATE_MULTIPLIER				  (float)8.06452E-09 //    ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)554.17824 //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h    15ھ103.86915  20ھ122.71875
 
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     ROUND_LLGS_XFZ_DN20_BRASS_40KPA_GP30_32768
#define   DEFAULT_START_FLOW  0x00D1 //DN20ͭ40KPAʱʹֵ
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.2//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.129817327// 25L/hӦʱֵ3.245433172
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00033333   //-200~-800nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000CCCC   //-200~-800nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              15      //10 16 25 150 4000У׼
#define   SEGMENT_NUM_MIDDLE             38
#define   SEGMENT_NUM_LARGE              136

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)12.8//0.8R250Q1ֵ
    
#define   TOF_UP_DATA                   (float)60160.65//20UPʱns
#define   LEGENTH_SPEED_SOUND           (float)89173.591031//·=1482.257772*TOF_UP_DATA   λum   
#define   LEGENTH_SPEED_SOUND_DAOSHU    (float)5.6070412e-9//·ȵ
    
#define   TOF_UP_DOWN_DAOSHUHE_LOW           (float)0.03397054  //1/up + 1/down    35
#define   TOF_UP_DOWN_DAOSHUHE_MIDDLE        (float)0.03428789 //1/up + 1/down    35~45

//ģ
#define   REAL_SOUND_PATH_LENGTH              (float)62////
#define   MEASYRING_TUBE_DIAMETER             (float)12.5   //1511.5,  2012.5
#define   FLOW_RATE_MULTIPLIER				  (float)8.064516e-9 //    ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)441.7875 //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h    15ھ103.86915  20ھ122.71875
 
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     MID_DN20_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN20ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.119770896// 
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              16
#define   SEGMENT_NUM_MIDDLE             23// ֮ǰ40 ޸0816
#define   SEGMENT_NUM_LARGE              155
#define   SEGMENT_NUM_ERROR_MIDDLE       43   //Ϊ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

//ģ----------------Ҫ޸Ĳ--------------------------------------------------------------------------------------
#define   REAL_SOUND_PATH_LENGTH              (float)59.95//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)13.6   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)8.3402836e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)485.82  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // PF 15:80.67  PF 20134.95

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1
    
#elif     EN_DN20_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN20ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  ((float)FLOW_RATE_FILTER_COEFFICIENT*2)//̨ʱ˲ϵ	
#define   DIFTOF_COEFFICIENT  (float)0.119770896// 
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              16
#define   SEGMENT_NUM_MIDDLE             38// ֮ǰ40 ޸0816
#define   SEGMENT_NUM_LARGE              128
#define   SEGMENT_NUM_ERROR_MIDDLE       43   //Ϊ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

//ģ----------------Ҫ޸Ĳ--------------------------------------------------------------------------------------
#define   REAL_SOUND_PATH_LENGTH              (float)59.95//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)13.6   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)8.3402836e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)485.82  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // PF 15:80.67  PF 20134.95

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1


#elif     BM_DN20_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN20ͭ63KPAʱʹֵ 700ps
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.114827154
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              14
#define   SEGMENT_NUM_MIDDLE             40
#define   SEGMENT_NUM_LARGE              160

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1
#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1

//20211205
#elif     PF_DN20_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00B7 //DN20ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.119770896// 
#define   R400Q1              (float)10
#define   R400Q2              (float)16
#define   R250Q2              (float)25
#define   Q3_3_3              (float)1320
#define   Q3_6_6              (float)2640
#define   MIN_FLOW_0_6              0x80000//С50%
#define   MAX_FLOW_1_02             0x14050000//102%
#define   MIN_FLOW_0_3              0x40000//С25%
#define   LIMIT_FLOW_1_5Q4          7500//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              16
#define   SEGMENT_NUM_MIDDLE             23// ֮ǰ40 ޸0816
#define   SEGMENT_NUM_LARGE              155
#define   SEGMENT_NUM_ERROR_MIDDLE       43   //Ϊ4εĽģ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

//ģ----------------Ҫ޸Ĳ--------------------------------------------------------------------------------------
#define   REAL_SOUND_PATH_LENGTH              (float)59.95//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)13.6   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)8.3402836e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)485.82  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // PF 15:80.67  PF 20134.95

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define FLOAT_BETWEEN_DATA_DIF_MAX    (float)3.8//950nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_SWITCH_STATE_THRESHOLD    (float)3.4//850nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_BETWEEN_DATA_DIF        	(float)2.2//550nsʱӦ˲ʱfloatֵ=550/250	  ֮Ĳֵ
#define FLOAT_LAST_DATA_MAX_THRESHOULD     	(float)1.4//350nsʱӦ˲ʱfloatֵ=350/250	  һݵжֵ    жжǸ-350
#define FLOAT_LAST_DATA_MIN_THRESHOULD      (float)1.84//460nsʱӦ˲ʱfloatֵ=460/250	  һݵжֵ    жжǸ-460
#define FLOAT_SWITCH_STATE_CURRENT_THRESHOLD        (float)0.64//160nsʱӦ˲ʱfloatֵ=160/250	  ٽ״̬ǰݵֵ

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     BM_DN25_BRASS_63KPA_GP30_32768  
#define   DEFAULT_START_FLOW   0xEC //DN25ͭ63KPAʱʹֵ 900ps 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.123358832 //25L/hӦʼֵ 
#define   R400Q1              (float)16
#define   R400Q2              (float)25
#define   R250Q2              (float)40
#define   Q3_3_3              (float)2079
#define   Q3_6_6              (float)4158
#define   MIN_FLOW_0_6              0xF0000//С50%
#define   MAX_FLOW_1_02             0x1F600000//102%
#define   MIN_FLOW_0_3              0x60000//С25%
#define   LIMIT_FLOW_1_5Q4          11700//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00039999   //-100~900nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x80006666   //-100~900nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              22
#define   SEGMENT_NUM_MIDDLE             60
#define   SEGMENT_NUM_LARGE              320

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1
#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1

#elif     DN25_BRASS_40KPA_GP30_32768 || LLGS_DN25_BRASS_40KPA_GP30_32768
#define   DEFAULT_START_FLOW   0xEC //DN25ͭ63KPAʱʹֵ 900ps 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.123358832 //25L/hӦʼֵ 
#define   R400Q1              (float)16
#define   R400Q2              (float)25
#define   R250Q2              (float)40
#define   Q3_3_3              (float)2079
#define   Q3_6_6              (float)4158
#define   MIN_FLOW_0_6              0xF0000//С50%
#define   MAX_FLOW_1_02             0x1F600000//102%
#define   MIN_FLOW_0_3              0x60000//С25%
#define   LIMIT_FLOW_1_5Q4          11700//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              35
#define   SEGMENT_NUM_MIDDLE             50
#define   SEGMENT_NUM_LARGE              320

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ


/*Ҫ޸Ĳ20211105*/
#define   SEGMENT_NUM_ERROR_MIDDLE          60

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q2)	//У׼С0.9Q1
#define   TOF_AM_VALUE                160//2022-09-17
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                      (float)20//0.8R250Q1ֵ

//ģ----------------Ҫ޸Ĳ--------------------------------------------------------------------------------------
#define   REAL_SOUND_PATH_LENGTH              (float)85//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)17   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)5.8823529e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)826.7796  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631  25 229.661mm2

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     MID_DN25_BRASS_63KPA_GP30_32768  
#define   DEFAULT_START_FLOW   0x106 //DN25ͭ63KPAʱʹֵ 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.125176377 //40L/hӦʱֵ4.862376622 
#define   R400Q1              (float)16
#define   R400Q2              (float)25
#define   R250Q2              (float)40
#define   Q3_3_3              (float)2079
#define   Q3_6_6              (float)4158
#define   MIN_FLOW_0_6              0xF0000//С50%
#define   MAX_FLOW_1_02             0x1F600000//102%
#define   MIN_FLOW_0_3              0x60000//С25%
#define   LIMIT_FLOW_1_5Q4          11700//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00039999   //-100~900nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x80006666   //-100~900nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              23////////???
#define   SEGMENT_NUM_MIDDLE             45////////???
#define   SEGMENT_NUM_LARGE              530

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1
#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1

//20211205
#elif     PF_DN25_BRASS_63KPA_GP30_32768  
#define   DEFAULT_START_FLOW   0xEC //DN25ͭ63KPAʱʹֵ 900ps 
#define   FLOW_RATE_FILTER_COEFFICIENT  (float)0.3//˲ʱ˲ϵ
#define   GP30_DIFTOF_FILTER_COEFFICIENT  (FLOW_RATE_FILTER_COEFFICIENT*(float)2)//̨ʱ˲ϵ
#define   DIFTOF_COEFFICIENT  (float)0.123358832 //25L/hӦʼֵ 
#define   R400Q1              (float)16
#define   R400Q2              (float)25
#define   R250Q2              (float)40
#define   Q3_3_3              (float)2079
#define   Q3_6_6              (float)4158
#define   MIN_FLOW_0_6              0xF0000//С50%
#define   MAX_FLOW_1_02             0x1F600000//102%
#define   MIN_FLOW_0_3              0x60000//С25%
#define   LIMIT_FLOW_1_5Q4          11700//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              35
#define   SEGMENT_NUM_MIDDLE             50
#define   SEGMENT_NUM_LARGE              320

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

/*Ҫ޸Ĳ20211105*/
#define   SEGMENT_NUM_ERROR_MIDDLE          60////

//ģ----------------------------Ҫ޸Ĳ-------
#define   REAL_SOUND_PATH_LENGTH              (float)85//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)17   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)5.8823529e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)826.7796  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631  25 229.661mm2

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define FLOAT_BETWEEN_DATA_DIF_MAX    (float)3.8//950nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_SWITCH_STATE_THRESHOLD    (float)3.4//850nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_BETWEEN_DATA_DIF        	(float)2.2//550nsʱӦ˲ʱfloatֵ=550/250	  ֮Ĳֵ
#define FLOAT_LAST_DATA_MAX_THRESHOULD     	(float)1.4//350nsʱӦ˲ʱfloatֵ=350/250	  һݵжֵ    жжǸ-350
#define FLOAT_LAST_DATA_MIN_THRESHOULD      (float)1.84//460nsʱӦ˲ʱfloatֵ=460/250	  һݵжֵ    жжǸ-460
#define FLOAT_SWITCH_STATE_CURRENT_THRESHOLD        (float)0.64//160nsʱӦ˲ʱfloatֵ=160/250	  ٽ״̬ǰݵֵ
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     DN32_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x0106 
#define   DIFTOF_COEFFICIENT  (float)0.081530677//40L/hӦʱֵ
#define   R400Q1              (float)25
#define   R400Q2              (float)40
#define   R250Q2              (float)64
#define   Q3_3_3              (float)3300
#define   Q3_6_6              (float)6600
#define   MIN_FLOW_0_6              0x140000//С50%
#define   MAX_FLOW_1_02             0x31CE0000//102%
#define   MIN_FLOW_0_3              0xA0000//С25%
#define   LIMIT_FLOW_1_5Q4          18750//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x0003AE14   //-80~920nsʱжϣʱΪ     2022-08-09
#define   LIMIT_DIFTOF_REVERSE          0x800051EB   //-80~920nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              50
#define   SEGMENT_NUM_MIDDLE             120
#define   SEGMENT_NUM_LARGE              520

/*Ҫ޸Ĳ20211105*/
#define   SEGMENT_NUM_ERROR_MIDDLE       130   //ֵ

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

//ģ----------------------------Ҫ޸Ĳ-------
#define   REAL_SOUND_PATH_LENGTH              (float)85//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)21   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)5.8823529e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)1252.1376  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)20//0.8R400Q1ֵ
	
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     BM_DN32_BRASS_63KPA_GP30_32768 
#define   DEFAULT_START_FLOW   0x0106 
#define   DIFTOF_COEFFICIENT  (float)0.081530677//40L/hӦʱֵ
#define   R400Q1              (float)25
#define   R400Q2              (float)40
#define   R250Q2              (float)64
#define   Q3_3_3              (float)3300
#define   Q3_6_6              (float)6600
#define   MIN_FLOW_0_6              0x140000//С50%
#define   MAX_FLOW_1_02             0x31CE0000//102%
#define   MIN_FLOW_0_3              0xA0000//С25%
#define   LIMIT_FLOW_1_5Q4          18750//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00039999   //-100~900nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x80006666   //-100~900nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              55//ֶζһ²Ե
#define   SEGMENT_NUM_MIDDLE             80//ֶζһ²Ե
#define   SEGMENT_NUM_LARGE              520

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define   TOF_AM_VALUE                190
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)20//0.8R400Q1ֵ
	
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

//20211205
#elif     PF_DN32_BRASS_63KPA_GP30_32768 	
#define   DEFAULT_START_FLOW   0x106 
#define   DIFTOF_COEFFICIENT  (float)0.081530677//40L/hӦʱֵ
#define   R400Q1              (float)25
#define   R400Q2              (float)40
#define   R250Q2              (float)64
#define   Q3_3_3              (float)3300
#define   Q3_6_6              (float)6600
#define   MIN_FLOW_0_6              0x140000//С50%
#define   MAX_FLOW_1_02             0x31CE0000//102%
#define   MIN_FLOW_0_3              0xA0000//С25%
#define   LIMIT_FLOW_1_5Q4          18750//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              50
#define   SEGMENT_NUM_MIDDLE             75
#define   SEGMENT_NUM_LARGE              520

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

/*Ҫ޸Ĳ20211105*/
#define   SEGMENT_NUM_ERROR_MIDDLE       120   //Ϊ4εĽģ

//ģ----------------------------Ҫ޸Ĳ-------
#define   REAL_SOUND_PATH_LENGTH              (float)85//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)21   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)5.8823529e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)1252.1376  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define FLOAT_BETWEEN_DATA_DIF_MAX    (float)3.8//950nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_SWITCH_STATE_THRESHOLD    (float)3.4//850nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_BETWEEN_DATA_DIF        	(float)2.2//550nsʱӦ˲ʱfloatֵ=550/250	  ֮Ĳֵ
#define FLOAT_LAST_DATA_MAX_THRESHOULD     	(float)1.4//350nsʱӦ˲ʱfloatֵ=350/250	  һݵжֵ    жжǸ-350
#define FLOAT_LAST_DATA_MIN_THRESHOULD      (float)1.84//460nsʱӦ˲ʱfloatֵ=460/250	  һݵжֵ    жжǸ-460
#define FLOAT_SWITCH_STATE_CURRENT_THRESHOLD        (float)0.64//160nsʱӦ˲ʱfloatֵ=160/250	  ٽ״̬ǰݵֵ

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     DN40_BRASS_63KPA_GP30_32768
#define   DEFAULT_START_FLOW   0x00D2   //800ps
#define   DIFTOF_COEFFICIENT  (float)0.042673614 //64 L/hӦʱֵ
#define   R400Q1              (float)40
#define   R400Q2              (float)64
#define   R250Q2              (float)102
#define   Q3_3_3              (float)5280
#define   Q3_6_6              (float)10560
#define   MIN_FLOW_0_6              0x200000//С50%
#define   MAX_FLOW_1_02             0x4FB00000//102%
#define   MIN_FLOW_0_3              0x100000//С25%
#define   LIMIT_FLOW_1_5Q4          30000//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x0003AE14   //-80~920nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x800051EB   //-80~920nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              76
#define   SEGMENT_NUM_MIDDLE             530//
#define   SEGMENT_NUM_LARGE              2700

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

/*Ҫ޸Ĳ20211105*/
#define   SEGMENT_NUM_ERROR_MIDDLE       550   ////ֵû

//ģ----------------------------Ҫ޸Ĳ-------
#define   REAL_SOUND_PATH_LENGTH              (float)85//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)26   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)5.8823529e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)1935.0432  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631


#define   CALIBRATION_PROTECT_VALUE      ((float)0.9*R400Q1)		//У׼С0.9Q1
#define   TOF_AM_VALUE                250
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)32//0.8R400Q1ֵ

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#elif     BM_DN40_BRASS_63KPA_GP30_32768 
#define   DEFAULT_START_FLOW   0x00D2   //800ps
#define   DIFTOF_COEFFICIENT  (float)0.042673614 //64 L/hӦʱֵ
#define   R400Q1              (float)40
#define   R400Q2              (float)64
#define   R250Q2              (float)102
#define   Q3_3_3              (float)5280
#define   Q3_6_6              (float)10560
#define   MIN_FLOW_0_6              0x200000//С50%
#define   MAX_FLOW_1_02             0x4FB00000//102%
#define   MIN_FLOW_0_3              0x100000//С25%
#define   LIMIT_FLOW_1_5Q4          30000//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x00039999   //-100~900nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x80006666   //-100~900nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              80
#define   SEGMENT_NUM_MIDDLE             120 //100ֵ107102ĵҲȥ
#define   SEGMENT_NUM_LARGE              2600

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ


#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define   TOF_AM_VALUE                250
#define   TOF_UP_AM_0_8               (0.8*TOF_AM_VALUE)//upֵ0.8
#define   TOF_DOWN_AM_0_8             (0.8*TOF_AM_VALUE)//downֵ0.8
#define   Q1_0_8                 (float)32//0.8R400Q1ֵ

//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

//20211205
#elif     PF_DN40_BRASS_63KPA_GP30_32768 
#define   DEFAULT_START_FLOW   0xD2   //800ps
#define   DIFTOF_COEFFICIENT  (float)0.042673614 //64 L/hӦʱֵ
#define   R400Q1              (float)40
#define   R400Q2              (float)64
#define   R250Q2              (float)102
#define   Q3_3_3              (float)5280
#define   Q3_6_6              (float)10560
#define   MIN_FLOW_0_6              0x200000//С50%
#define   MAX_FLOW_1_02             0x4FB00000//102%
#define   MIN_FLOW_0_3              0x100000//С25%
#define   LIMIT_FLOW_1_5Q4          30000//1.5Ĺ
#define   LIMIT_DIFTOF_FORWARD          0x000347AE   //-220~820nsʱжϣʱΪ
#define   LIMIT_DIFTOF_REVERSE          0x8000E147   //-220~-820nsʱжϣʱΪ
#define   SEGMENT_NUM_SMALL              76
#define   SEGMENT_NUM_MIDDLE             530//
#define   SEGMENT_NUM_LARGE              2700

#define   DXS_SEGMENT_NUM_LARGE          280 //ʽĻģͷֵֶ

/*Ҫ޸Ĳ20211105*/
#define   SEGMENT_NUM_ERROR_MIDDLE       550   ////ֵû

//ģ----------------------------Ҫ޸Ĳ-------
#define   REAL_SOUND_PATH_LENGTH              (float)85//(float)74.863   //L*cos   D*cot D׼ȷ  2021-2-1Ϊߴ    2021-7-21 1559.82059.95
#define   MEASYRING_TUBE_DIAMETER             (float)26   //1510.7,  2013.6
#define   FLOW_RATE_MULTIPLIER				  (float)5.8823529e-9//(float)6.6788667e-9  //  ټ㳣=  1e-9/(2*(LЧ))/0.001
#define   FLOW_MULTIPLIER				      (float)1935.0432  //  㳣=  (3.1416*D*D*1e-6/4 )*3600 *1000L/h   // 15:93.3307  20146.631

#define   CALIBRATION_PROTECT_VALUE       ((float)0.9*R400Q1)	//У׼С0.9Q1
#define FLOAT_BETWEEN_DATA_DIF_MAX     (float)3.8//950nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_SWITCH_STATE_THRESHOLD    (float)3.4//850nsʱӦ˲ʱfloatֵ=850/250	  ٽ״̬лֵ
#define FLOAT_BETWEEN_DATA_DIF        	(float)2.2//550nsʱӦ˲ʱfloatֵ=550/250	  ֮Ĳֵ
#define FLOAT_LAST_DATA_MAX_THRESHOULD     	(float)1.4//350nsʱӦ˲ʱfloatֵ=350/250	  һݵжֵ    жжǸ-350
#define FLOAT_LAST_DATA_MIN_THRESHOULD      (float)1.84//460nsʱӦ˲ʱfloatֵ=460/250	  һݵжֵ    жжǸ-460
#define FLOAT_SWITCH_STATE_CURRENT_THRESHOLD        (float)0.64//160nsʱӦ˲ʱfloatֵ=160/250	  ٽ״̬ǰݵֵ
//ߵ
//#define   SUBSECTION_NUM_THREE           1
#define   SUBSECTION_NUM_FOUR            1
//#define   SUBSECTION_NUM_FIVE            1

#endif

#define   MIN_START_FLOW      0x1A   //100ps  ӦGp30ʽ 0.1/250*65536
#define   MAX_START_FLOW      0x189  //1500ps  ӦGp30ʽ 1.5/250*65536

#define   MIN_FLOW_TO_PS      0x64   //100ps  Ӧʮ
#define   MAX_FLOW_TO_PS      0x05DC  //1500ps  Ӧʮ

//#define RESET_LIMIT_DATE               200 //λ޶ֵDN15 250 ,DN20 400,  DN25 500, DN32 1000, DN40 1200
//Ҫ: ˲
/*************************궨****************************/
#define  GP22_APP_S0                   0
#define  GP22_APP_S1                   1
#define  GP22_APP_S2                   2
#define  GP22_APP_S3                   3
#define  GP22_APP_S10                  4

//
#define   GP22_APP_FLOW                     01   //GP22ֻ
#define   GP22_APP_FLOW_TEMP                10   //GP22+¶ȡ
//˲ʱű־
#define   GP22_APP_DIFTOF_POST                01   //˲ʱΪ
#define   GP22_APP_DIFTOF_NEGT                10   //˲ʱΪ

//Ƶ
#define   GP22_SAMPLE_2HZ                  1   //2Hz
#define   GP22_SAMPLE_1HZ                  2   //1Hz
#define   GP22_SAMPLE_0_5HZ                4   //0.5Hz
//춨״̬£ۻϵ
#define   FACTOR_0_5                  0.5   
#define   FACTOR_1                  	1   
#define   FACTOR_2                 		2   
// 0ʱֵ1˳ʱ䡢2ʱ 4ŵ˳ʱ
#define   GP22_APP_FLOW_DIFFER              0   //ʱֵ
#define   GP22_APP_UP_TOF                   1   //˳ʱ
#define   GP22_APP_DOWN_TOF                 2   //ʱ
#define   GP22_APP_STAND_DIFFER             3   //ȱʡ
#define   GP22_APP_FLOW_DIFFER_SIGN         4   //ŵ˳ʱ


//ӿڲѯ
#define GP30_APP_INS_FLOW                   1//˲ʱ
#define GP30_APP_TOTAL_FLOW                 2//ۼ
#define GP30_APP_TOTAL_FLOW_REVERSE         3//ۼ

#define GP30_APP_TOF          4//ʱup
#define GP30_APP_RATIO_UP     5//ȱup
#define GP30_APP_PEAK_UP      6//ֵup

#define GP30_APP_DOWN         7//ʱdown
#define GP30_APP_RATIO_DOWN   8//ȱDOWN
#define GP30_APP_PEAK_DOWN    9//ֵDOWN

#define GP30_APP_DIFF         10//ʱ
#define GP30_APP_INS_FLOW_LCD         12//춨״̬˲ʱʾ







//#define GP30_APP_TOTAL_FLOW_REVERSE   13//ۼ

#define GP30_APP_TEMP         14//¶  

//ԼݵMSG
#define   GP30_APP_STILL_WATER_FRAME        4   //ѯˮʱ 
#define   GP30_APP_CLEAR_DATA_FRAME         1   //GP30 ʵʱ

//
//#define   GP30_APP_QUEUE_SIZE       12
//#define   GP30_APP_START_FLOW_FILTER  	0xD1                                   //DN15DN20900700ps3.77L5 Lģ8006003.3L4.2
//#define GP22_APP_START_FLOW_RESERVER  	0x80000000|GP30_APP_START_FLOW_FILTER  //ʼDN15DN20900700ps3.77L5 Lģ8006003.3L4.2
//#define   GP30_APP_START_FLOW_FILTER_FOR_FLOAT  (float)GP30_APP_START_FLOW_FILTER/(float)65536
#define    MAX_TEMP_NUM               10//¶˲BUFFERֵ
#define    MAX_TOF_BUCHANG_NUM        150//ʱУ׼ݴ洢BUFFER----------ֵҪʵʻ̨Ӳ

#define    TOF_BUCHANG_IDLE                  0//ʱ䲹---״̬
#define    TOF_BUCHANG_START_SAMPLE          1//ʱ䲹---״̬


#define    GP30_DIFTOF_FILTER_ENABLE_MAX_VALUE               0x1EB8//GP30ʱ˲㷨õֵֻС30nsʱŻµ˲㷨


#define    TOF_MAX_DIF_FOR_HUADONG    0x0000E147// 150nsӦGP30ʽ   
#define    TOF_DIF_FOR_HUADONG        0x00023333// 550nsӦGP30ʽ
#define    TOF_UP_FOR_FILTER_FLAG     1//UPʱ˲־
#define    TOF_DOWN_FOR_FILTER_FLAG   0//DOwnʱ˲־
#define    TOF_6_US                   1572864 //6us ӦGP30ʽ

typedef union {
	u32 gp30_u32;
	float gp30_float;
} To_Float_GP30;

#define   GP30_APP_MAX_DATA         18   //GP30ݸ

typedef union {
    u32 gp30_u32;
    float gp30_float;
} To_Float;

typedef union {
    u64 gp30_u64;
    double gp30_double;
} To_Double;

typedef union {

	struct {
		u32 temp; //¶ȣGP30ݸʽ
		To_Float_GP30 total_flow; //ۼ(floatiEEE754Ǽ춨Ŵ100)
		To_Float_GP30 total_flow_reverse;//ۼ
		u32 ins_flow; //˲ʱGP30ݸʽ
		u32 TOF_up; //TOF_upֵGP30ݸʽ
		u32 ratio_up; //Pulse_Width_Ratio_UpGP30ݸʽ
		u32 peak_up; //ֵGP30ݸʽ//ֵ_up
		u32 TOF_down; //TOF_downֵGP30ݸʽ
		u32 ratio_down; //Pulse_Width_Ratio_downGP30ݸʽ
		u32 peak_down; //ֵGP30ݸʽ//ֵ_down
		u32 TOF_diff; //ʱGP30ݸʽ
        To_Float up_tof_dif; //UP˵ıֵ
        To_Float down_tof_dif; //DOwnıֵ
        u32 ins_flow_cnt;  //˲ʱܴһcnt1
        float ins_flow_sum;//˲ʱܺͣһsum1
		float ins_flow_sum_temp;//˲ʱۼʱֵ
		float ins_flow_max;//˲ʱֵ
		float ins_flow_min;//˲ʱСֵ
		
	}s;
	u32 data[GP30_APP_MAX_DATA]; //ǰ
} GP30_SYS_Date;
	
	
typedef struct {
    u16 communication_err;
    u16 no_water;
    u16 low_flow;
    u16 out_temp;
    u16 low_high_flow;
    u16 reverse_flow;
	u16 tof_overrun;
	u16 low_amp;
	u16 gp30_err;
    u16 water_direction_reverse;//ˮ
} EVENT;

typedef struct {
    u8 communication_err;
    u8 no_water;
    u8 low_flow;
    u8 out_temp;
    u8 low_high_flow;
    u8 reverse_flow;
	u8 tof_overrun;
	u8 low_amp;
	u8 gp30_err;
    u8 water_direction;//ˮ
} EVENT_FLAG;

typedef union {

    struct {
        u8 time[6]; //ʱ
        To_Float total_flow; //ۼ
        u16 state; //״̬
    }s;
    u8 data[12];
} GP30_APP_EVENT_DATA;

typedef struct {
    u8 diftof_overrun_num;
	u8 tdc_overrun_num;  //ˮ
	u8 tof_overrun_num;
	u8 type_err_num;
	u8 GP30_sample_err_num;
} OVERRUN_NUM;

#define   GP30_APP_EVENT_SUM_NORMAL      20
#define   GP30_APP_EVENT_SUM_TEST        160

#define   GP30_communication_err       1
#define   GP30_no_water        2
#define   GP30_low_flow        4
#define   GP30_out_temp        5
#define   GP30_low_high_flow      6
#define   GP30_reverse_flow     7
#define	  GP30_TOF_overrun      8
#define	  GP30_low_amp			9
#define	  GP30_err			3
#define	  GP30_water_direction 10


#define   GP30_communication_err_DE       11
#define   GP30_no_water_DE        22
#define   GP30_low_flow_DE        44
#define   GP30_out_temp_DE        55
#define   GP30_low_high_flow_DE   66
#define   GP30_reverse_flow_DE   77
#define   GP30_TOF_overrun_DE     88
#define	  GP30_low_amp_DE			99
#define	  GP30_err_DE				33
#define	  GP30_water_direction_DE 23		


#define   GP30_clear_all       0xFF

//2017-12-4 13:25:56
//#define   GP30_APP_LOWPOW_ERR_ADDR       0x800
//#define   GP30_APP_TRANS_ERR_ADDR       0x900
//#define   GP30_APP_NO_WATER_ADDR        0xA00
//#define   GP30_APP_LOW_FLOW_ADDR        0xB00
//#define   GP30_APP_OUT_TEMP_ADDR        0xC00

#define   GP30_APP_LOWPOW_ERR_ADDR       0x800   //2015-6-4  Ϊ洢¼
#define   GP30_APP_TRANS_ERR_ADDR       (GP30_APP_LOWPOW_ERR_ADDR + sizeof(GP30_APP_EVENT_DATA))
#define   GP30_APP_NO_WATER_ADDR        (GP30_APP_TRANS_ERR_ADDR + sizeof(GP30_APP_EVENT_DATA))
#define   GP30_APP_LOW_FLOW_ADDR        (GP30_APP_NO_WATER_ADDR + sizeof(GP30_APP_EVENT_DATA))
#define   GP30_APP_OUT_TEMP_ADDR        (GP30_APP_LOW_FLOW_ADDR + sizeof(GP30_APP_EVENT_DATA))


//¼ʱʱ6 +¼ʱۻ4 + ״̬2 =  12ֽڡÿ¼һ¼
//ϣ0x900 - 0x9FFGP30Ӧô:1СʱĴ90%ΪЧ¼
//ܶˮ0xA00 - 0xAFFGP30Ӧô:1СʱĴ90%ΪЧ¼
//0xB00 - 0xBFFGP30Ӧô:1СʱĴ90%ΪЧ¼
//ˮ³¶ȵȼΧ0xC00 - 0xCFFGP30Ӧô:1СʱĴ90%ΪЧ¼


//GP30㴦
//Ҫ: λǰ

#define   GP30_APP_CLEAR_DATA_S0                   0
#define   GP30_APP_CLEAR_DATA_S1                   1

#define   GP30_APP_DATA_ADDR                      EEP_GP30_BASE_ADDR     //ݱݵEEַ 0x100
#define   GP30_APP_DATA_TOTAL_FLOW_ADDR           (GP30_APP_DATA_ADDR +6)  //2017 02,ĸλ
#define   GP30_APP_DATA_TOTAL_FLOW_ADDR_REVERSE   (GP30_APP_DATA_ADDR +10) //2017 02,ĸλ
#define   GP30_APP_DATA_UP_TOF_DIF_ADDR           (GP30_APP_DATA_ADDR +14) //2021-03-22//
#define   GP30_APP_DATA_DOWN_TOF_DIF_ADDR         (GP30_APP_DATA_ADDR +18) //2021-03-22

#define	  DIFTOF_CALIBRATION_FLAG_ADDR			  0X150 //2021,04,ӻУ׼־0xA1B2C3D4E5F6A7B8ʾУ׼
#define	  DIFTOF_CALIBRATION_VALUE_ADDR			  (DIFTOF_CALIBRATION_FLAG_ADDR +8) //2021,04,ӻУ׼ֵ4ֽ
typedef union {

    struct {
        u8 flag[2]; //һϵ־
        u8 time[4]; //ʱ
        To_Float total_flow; //ۼ
		To_Float total_flow_reverse; //ۼ
        To_Float up_tof_dif; //UP˵ıֵ
        To_Float down_tof_dif; //DOwnıֵ
    }s;
    u8 data[22]; //ǰ
} GP30_APP_SAVE_DATA;
typedef union {

    struct {
        U8TOU64 diftof_calibration_flag; //ʱǷУ׼ı־
        U8TOU32 diftof_calibration_value; //ʱУ׼ֵ
    }s;
    u8 data[12]; 
} GP30_DIFTOF_CAL_DATA;

//ǰݱݴ
//Ҫ: GP30ǰۼݱݴ洢

/*************************궨****************************/
#define   GP30_APP_SAVE_S0                   0
#define   GP30_APP_SAVE_S1                   1
#define   GP30_APP_SAVE_S2                   2
#define   GP30_APP_SAVE_S3                   3
#define   GP30_APP_SAVE_S4                   4
#define   GP30_APP_SAVE_S5                   5
#define   GP30_APP_SAVE_S6                   6

#define   SAMPLE_INTERVAL_1h                 3600   //ݱ
#define   FLOW_DETECT_5S               3   //


//GP22Ӧôϵʼ
//Ҫ: GP22Ӧôϵʼ EEݶȡ 
//EEPROM 0x80-0xB7
//һϵ־: 0x77 0x88

#define   GP30_APP_INIT_S0                   0
#define   GP30_APP_INIT_S1                   1
#define   GP30_APP_INIT_S2                   2
#define   GP30_APP_INIT_S3                   3
#define   GP30_APP_INIT_S4                   4
#define   GP30_APP_INIT_S5                   5
#define   GP30_APP_INIT_S6                   6
#define   GP30_APP_INIT_S7                   7
#define   GP30_APP_INIT_S8                   8

//GP22
#define   GP22_APP_SAMPLE_S0      0
#define   GP22_APP_SAMPLE_S1      1
#define   GP22_APP_SAMPLE_S2     2
#define   GP22_APP_SAMPLE_S3      3
#define   GP22_APP_SAMPLE_S4      4

//Send_Dataϱ
#define		SEND_DATA_S0			0
#define		SEND_DATA_S1			1
#define		SEND_DATA_S2			2
#define		SEND_DATA_S3			3

//л
#define		GP30_CONTROL_S0			0
#define		GP30_CONTROL_S1			1

#define   GP30_APP_FLOW_DETECT_S0                   0//ټ״̬ 2022-05-30
#define   GP30_APP_FLOW_DETECT_S1                   1
#define   GP30_APP_FLOW_DETECT_S2                   2
#define   GP30_APP_FLOW_DETECT_S3                   3


//λ20211213
//״̬
#define  MSASURE_STATE_OPEN         0
#define  MSASURE_STATE_SWITCH       1
#define  MSASURE_STATE_CLOSE        2
//#define   GP22_APP_SAMPLE_SIZE                        6   //GP22ÿGP22_APP_SAMPLE_SIZE νһ¶Ȳɼ,һΡ
//#define   GP22_APP_QUEUE_SIZE                         12   //GP22˲Ԫظ


//#define   GP22_APP_DIFTOF_SIZE                        10   //GP22ʱԪظ
//#define   GP22_APP_DIFTOF_SIZE_2                      60   //ڶԪظ

#define   GP22_APP_QUEUE_SIZE                         16  //GP22˲Ԫظ
#define   GP22_APP_TEMP_INVERSE_DATA_SIZE               3  //GP22FHLģʽUPDOWNʱԪظ
#define   GP22_APP_TEMP_INVERSE_DATA_SIZE_FIVE              5  //GP22FHLģʽUPDOWNʱԪظ

#define   GP30_APP_FILTER_SIZE                        (GP22_APP_QUEUE_SIZE/4)  //춨״̬¼ۼ˲ֵ
#define   GP30_APP_FILTER_MAX_MIN_SIZE                (GP30_APP_FILTER_SIZE/2)  //GP30춨״̬¼ۼ˲ֵ,С

#define   GP22_APP_DIFTOF_SIZE                        GP22_APP_QUEUE_SIZE   //GP22ʱԪظ


#if EN_SMALL_FILITER
#define   GP22_APP_DIFTOF_SIZE_2                      40   //ڶԪظ   16*40 = 640
#elif EN_LARGE_FILITER
#define   GP22_APP_DIFTOF_SIZE_2                      20   //ڶԪظ 
#define   GP22_APP_DIFTOF_SIZE_3                      30   //Ԫظ   16*30 *20 = 9600 //10ӳ˲
#define   GP22_APP_DIFTOF_SUM                         600   //˲   30*20  //10ӳ˲
#endif 

#define   SAMPLE_FREQUENCY_NON_VERIFICATION                     8  //GP30Ǽ춨״̬Ƶ
#define   TOTAL_FLOW_COEFFICIENT_NON_VERIFICATION        		(GP22_APP_QUEUE_SIZE / SAMPLE_FREQUENCY_NON_VERIFICATION)  //Ǽ춨״̬ۼ õϵ

#define   SAMPLE_FREQUENCY_VERIFICATION                      16  //GP30춨״̬Ƶ
#define   TOTAL_FLOW_COEFFICIENT_VERIFICATION          	 	 (GP22_APP_QUEUE_SIZE / SAMPLE_FREQUENCY_VERIFICATION)  //춨״̬ۼ õϵ
#define   GP22_APP_EXCEED_START_FLOW_SUM                     3/*       ޸ԭ򣺴ֵд2ڷ;GP22_APP_QUEUE_SIZE/8    //GP30_APP_FILTER_SIZE     ʼʱھˮ㷨 2019-5-7*/
#define   GP22_APP_EXCEED_START_FLOW_SUM_VERIFICATION        (GP22_APP_QUEUE_SIZE/2)    //ڼ춨״̬GP30_APP_FILTER_SIZE     //ʼʱھˮ㷨 2019-5-7
#define   GP22_APP_MAX_AM_BUFFER        					 (GP22_APP_QUEUE_SIZE/2)    //ڼ춨״̬GP30_APP_FILTER_SIZE     //ʼʱھˮ㷨 2019-5-7
#define   GP22_MAX_BUFFERLENTH                         16  //GP30bufferlenth

#define   INS_FLOW_CAL_CNT_MAX                     1800//30˲ʱѭһ
//GP22ݴ洢
#define   GP22_APP_MONITOR_S(X)      X
/*
 *
while (!g_gp22_init_flag)
{
    GP22Ӧôϵʼ 
    EE
}*/

//ӿʹ
#define  SLEEP_TRUE                1
#define  SLEEP_FALSE               0

//ӿʹ
#define  GP30_APP_IDLE             1
#define  GP30_APP_BUSY             0
#define  GP30_APP_TEST             2


//

#define   GP22_APP_3P6          0x00039999   //3.6


#define   GP22_APP_TOTAL_FLOW_PARA_NOR          0x0000071C   //100/3600 Ǽ춨 Ŵ100
#define   GP22_APP_TOTAL_FLOW_PARA_JIAN         0x0000071C   //100000/3600/1000 춨 Ŵ100000

//#define   GP22_APP_TOTAL_FLOW_PARA_NOR          0x0000071C   //100/3600 Ǽ춨 Ŵ100
//#define   GP22_APP_TOTAL_FLOW_PARA_JIAN         0x0000071C   //100000/3600 춨 Ŵ100000    Ѽ춨״̬ msת  /1000  ͬ
#define   GP22_APP_1_3600                       0x0000471D    // 1000 /3600

#define   GP22_APP_TOTAL_HEAT_PARA_NOR          0x0000071C   //100/3600 Ǽ춨 Ŵ100
#define   GP22_APP_TOTAL_HEAT_PARA_JIAN         0x00000012   //1000/3600 춨 Ŵ1000    /1000 תms

extern GP30_DIFTOF_CAL_DATA g_diftof_cal_data;//У׼ʱͱ־
/*---------------------------------- Function Declare -----------------------------------*/
void Gp30MachineApp(void);
void Gp30InitApp(void);
u32 Gp30CheckDataApp(u8 data_para);
u32 Gp30CheckTestDataApp(u8 data_para);
u8 Gp30IfSleepApp(void);
u8 Gp30InitDataApp(u32 total_flow, u32 negative_total_flow);
u8 Gp30CurInitDataApp(u32 cur_total_flow);
//void Gp30TestFlowInit(void);
void gp22CheckErrEventApp (u8 err_event);
u8 Gp30CheckBootloaderMsgApp(void);
u32 Gp30GetTestRamFlag(void);
void Meter_ResetCountAdd(u8 reason);
u16 Meter_GetResetCount(void);
u16 Gp30CheckErrDataApp(void);
void Gp30StartMeasureApp(u8 flag);
//u8 Gp30CheckSetWindowApp(void);
//void Gp30ClearSetWindowApp(void);
u32 FilterJunZhi(u32 *data, u8 data_len);

u8 Check_Start_STOP_Filter_Flag(void);//ȡ¶Ƿ˲־
void Clear_Start_STOP_Filter_Flag(void);//¶Ƿ˲־
float Check_Temperature_Parameter(void);//ȡ˲¶
	
u32 FloatToGp30Data(float data);
float Gp30DataToFloat(u32 data);
u32 bcdToHex32(u32 value);
void Gp22AppSetGp22Err(void);
void FlowIntvalTimeLPTimer(void);
void RecordCalculativeIntvalTimeLPTimer(void);
void NormalResetCompensation(void);
void Gp30DiftofCalibration(void);
u8 CheckAutoCalibrationMsg(void);
u8 CheckTransducerErrorMsg(void);
u8 CheckDiftofCalibrationFlag(void);

float ModifyForVolumeTestbench(float temp_ins_flow_float);
float modify_flow( float ins_flow_temp_float);//㵱ǰ
u8 GP30_Check_Data_UpdateMsg(void);
void GP30_Set_Data_UpdateMsg(void);
void GP30_Clear_Data_UpdateMsg(void);

void DiftofForTestbench(float temp_ins_flow_float);
//void VerificationResetCompensation(void);

//extern u16 g_test_start_sum ;
//extern u16 g_test_stop_sum ;

#endif	/* __UWater_GP30_APP_H */



