/*******************************************************************************
* @Copyright (c)    :(C)2016, Qingdao ieslab Co., Ltd
* @FileName         :GP22Gas_sys.h
* @Author           :team
* @Version          :V1.0
* @Date             :2016423 10:59:44
* @Description      :the function of the entity of GP22Gas_sys.h
*******************************************************************************/
#ifndef __UWater_sys_H
#define __UWater_sys_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "type.h"
#include "sys_config.h"
/* Exported types ------------------------------------------------------------*/
/* Exported constants --------------------------------------------------------*/
/* Exported macro ------------------------------------------------------------*/
#if (HARDWARE_VERSION==0x14)//Ǳ
#define LED_PORT		GpioPortC
#define LED_PIN		  	GpioPin13
#elif (HARDWARE_VERSION==0x18)//ԲǱ
#define LED_PORT		GpioPortF
#define LED_PIN		  	GpioPin7
#endif

void Clk_Init(void);
void UnusedGpioInit(void);
void Meter_ResetCountAdd(u8 reason);
u16 Meter_GetResetCount(void);
void Meter_BootVersionInit(void);
u16 Meter_GetBootVersion(void);//ȡBOOT汾
#ifdef __cplusplus
}
#endif

#endif /* __UWater_sys_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/

