/*******************************************************************************
* @Copyright (c)    :(C)2016, Qingdao ieslab Co., Ltd
* @FileName         :GP22Gas_valve_app.c
* @Author           :Kv-L
* @Version          :V1.0
* @Date             :2016525 13:54:51
* @Description      :the function of the entity of GP22Gas_valve_app.c
*******************************************************************************/

#ifdef __cplusplus
extern "C" {
#endif

#include "UWater_valve_app.h"
#include "UWater_valve_driver.h"
#include "UWater_rtcc_app.h"
#include "UWater_gp22_app.h"
#include "SOE.h"
#if defined(VALVE)
static u8 valve_rcv_order = 0;						//ص
static u8 valve_rcv_order_backup = 0;				//ֹ壬¼ϴյ
static u8 valve_deal_state = VALVE_DEAL_S0;			//
static DateTime sys_rtcc_time_valve;				//ڻȡϵͳǰʱ
static Fram_To_Float valve_tmp_float;
static u8 s_valapp_upload_state = 0;//طϱ

static u8 ValveCheckOrder(void)
{
	u8 result_return = FALSE;
	//EE״̬
	switch(Sys_data_object.P1.ies_valve_paras.valve_state)					
	{
		case VALVE_STATE_OPEN:				
		{
			/*ͨ״̬:
			(1)յչءӦءȨ޹,淧״̬ط
			*/
			switch(valve_rcv_order_backup)	
			{
				case VALVE_STATE_OPEN:
                case VALVE_STATE_OPEN_EMERGENCY:
                {
                    ValveStartTask(VALVE_TO_OPEN);	//0208
                }
                break;
				case VALVE_STATE_CLOSE:
				case VALVE_STATE_CLOSE_EMERGENCY:
				case VALVE_STATE_CLOSE_LOCK:
				{
					ValveStoreRcvState(valve_rcv_order_backup);
					ValveStartTask(VALVE_TO_CLOSE);
					result_return = TRUE;
				}
				break;
				default:
					break;
			}
		}
		break;
		
		case VALVE_STATE_OPEN_EMERGENCY:	
		{
			/*Ӧ״̬:
			(1)յչءӦءȨ޹,淧״̬ط
			(2)лͨ״̬(ͨ״̬ˮ)
			*/ 
			switch(valve_rcv_order_backup)	
			{
				case VALVE_STATE_OPEN_EMERGENCY:
                {
                    ValveStartTask(VALVE_TO_OPEN);	//0208
                }
                break;
                case VALVE_STATE_OPEN:
                {
					ValveStartTask(VALVE_TO_OPEN);	//0208
                    ValveStoreRcvState(valve_rcv_order_backup);
                    result_return = TRUE;
                }
                break;
				
				case VALVE_STATE_CLOSE:
				case VALVE_STATE_CLOSE_EMERGENCY:
				case VALVE_STATE_CLOSE_LOCK:
				{
					ValveStoreRcvState(valve_rcv_order_backup);
					ValveStartTask(VALVE_TO_CLOSE);
					result_return = TRUE;
				}
				break;
				default:
					break;
			} 
		}
		break;
		
		
		case VALVE_STATE_CLOSE:				
		{
			/*ͨط״̬:
			(1)лӦءȨ޹
			(2)ͨӦ
			*/
			switch(valve_rcv_order_backup)	
			{				
				case VALVE_STATE_OPEN:
				case VALVE_STATE_OPEN_EMERGENCY:
				{
					ValveStoreRcvState(VALVE_STATE_OPEN);//ͨط״̬µκο,Ϊͨ(ˮ)
					ValveStartTask(VALVE_TO_OPEN);
					result_return = TRUE;
				}
				break;
				case VALVE_STATE_CLOSE:
                {
                    ValveStartTask(VALVE_TO_CLOSE);	//0208
                }
                break;
                case VALVE_STATE_CLOSE_EMERGENCY:
                case VALVE_STATE_CLOSE_LOCK:
                {
					ValveStartTask(VALVE_TO_CLOSE);	//0208
                    ValveStoreRcvState(valve_rcv_order_backup);
                    result_return = TRUE;
                }
                break;
				default:
					break;
			}
		}
		break;
		case VALVE_STATE_CLOSE_EMERGENCY:
		{
			/*Ӧط״̬:
			(1)лӦ¼ӦˮȴﵽӦˮʱлΪȨ޹ط
			(2)ͨ,ͨ״̬ˮ
			(3)лͨط\Ȩ޹ط
			*/
			switch(valve_rcv_order_backup)	
			{				
				case VALVE_STATE_OPEN_EMERGENCY:
				{
					valve_tmp_float.gp22_u32 = Gp30CheckDataApp(2);
					//Ӧˮ L
					Sys_data_object.P1.ies_pulse_remain.datas = (u32)(valve_tmp_float.gp22_float) + Sys_data_object.P1.ies_pulse_emergency.datas*100;
					FrameSetMsgApp(MsgValve_EmergencyFlowStore);
                    ValveStoreRcvState(valve_rcv_order_backup);
					ValveStartTask(VALVE_TO_OPEN);
					result_return = TRUE;
				}
				break;
				case VALVE_STATE_OPEN:
				{
					ValveStoreRcvState(valve_rcv_order_backup);
					ValveStartTask(VALVE_TO_OPEN);
					result_return = TRUE;
				}
				break;
                case VALVE_STATE_CLOSE:
                case VALVE_STATE_CLOSE_LOCK:
                {
					ValveStartTask(VALVE_TO_CLOSE);	//0208
                    ValveStoreRcvState(valve_rcv_order_backup);
                    result_return = TRUE;
                }
                break;
				case VALVE_STATE_CLOSE_EMERGENCY:
                {
                    ValveStartTask(VALVE_TO_CLOSE);	//0208
                }
                break;
				default:
					break;
			}
		}
		break;
		
		case VALVE_STATE_CLOSE_LOCK:
		{
			/*Ȩ޹ط״̬:
			(1)ͨ
			(2)ͨ,ͨ״̬ˮ
			(3)лͨط\Ӧط
			*/
			switch(valve_rcv_order_backup)	
			{
				case VALVE_STATE_OPEN:
				{
					ValveStoreRcvState(valve_rcv_order_backup);
					ValveStartTask(VALVE_TO_OPEN);
					result_return = TRUE;
				}
				break;
				
                case VALVE_STATE_CLOSE:
                case VALVE_STATE_CLOSE_EMERGENCY:
                {
					ValveStartTask(VALVE_TO_CLOSE);	//0208
                    ValveStoreRcvState(valve_rcv_order_backup);
                    result_return = TRUE;
                }
                break;
				case VALVE_STATE_CLOSE_LOCK:
                {
                    ValveStartTask(VALVE_TO_CLOSE);	//0208
                }
                break;
				default:
				break;
			}
		}
		break;
		default:
		{
		}
		break;
	}
	return result_return;
}

//ģϵͳ
void ValveDealAppMachine(void)
{
	if(VALVE_STATE_OPEN_EMERGENCY == Sys_data_object.P1.ies_valve_paras.valve_state)
	{
		valve_tmp_float.gp22_u32 = Gp30CheckDataApp(2);
		if(valve_tmp_float.gp22_float > Sys_data_object.P1.ies_pulse_remain.datas)//ˮ趨ˮ
		{
			ValveDealAppStart(VALVE_STATE_CLOSE_LOCK);//Ȩ޹ط
		}   
	}
	else if(FrameCheckMsgApp(Msg_ValveOpenEmergency))
	{
		FrameClearMsgApp(Msg_ValveOpenEmergency);
		if((VALVE_STATE_CLOSE_EMERGENCY == Sys_data_object.P1.ies_valve_paras.valve_state)||(VALVE_STATE_CLOSE == Sys_data_object.P1.ies_valve_paras.valve_state))
		{
			ValveDealAppStart(VALVE_STATE_OPEN_EMERGENCY);
		}
	}
    switch(valve_deal_state)
    {
        case (VALVE_DEAL_S0):
        {
            if(valve_rcv_order)	//ط
            {
                valve_rcv_order_backup = valve_rcv_order;	//ݿطֹµĿطָ串
                valve_rcv_order = 0;
                valve_deal_state = VALVE_DEAL_COMMON;
            }
            else if(RtccCheckMsgApp(RtccMsg_ValveActive))	//ʱϢ,ÿ1230
            {
                RtccClearMsgApp(RtccMsg_ValveActive);
				RtccGetDateTime(&sys_rtcc_time_valve);
				if((0x01 == sys_rtcc_time_valve.s.day) && 
					(0x23 == sys_rtcc_time_valve.s.hour) && 
					(0x00 == sys_rtcc_time_valve.s.minute) && 
					(VALVE_AUTO_CHECK_OPEN == Sys_data_object.P1.ies_valve_up_times.valve_auto_check))
				{
					//ǰ״̬ΪӲ·
					if((VALVE_STATE_OPEN == Sys_data_object.P1.ies_valve_paras.valve_state) || 
					   (VALVE_STATE_OPEN_EMERGENCY == Sys_data_object.P1.ies_valve_paras.valve_state))	//ǰ״̬Ϊ
					{
						valve_deal_state = VALVE_DEAL_ACTIVE_HALF;
					}
				}
            }
        }
        break;

        case (VALVE_DEAL_COMMON):	//ط
        {
            if (ValveIfIdle())
            {
				if(ValveCheckOrder())		//жǷҪEE״̬ط
				{
					switch(valve_rcv_order_backup)			//SOE
					{
						case VALVE_STATE_OPEN:
						{
							SaveNewSoe(SOE_VALVE_OPEN,SOE_REMARK_NOR);
						}
						break;
						case VALVE_STATE_OPEN_EMERGENCY:
						{
							SaveNewSoe(SOE_VALVE_OPEN_EMERGENCY,SOE_REMARK_NOR);
						}
						break;
						case VALVE_STATE_CLOSE:
						{
							SaveNewSoe(SOE_VALVE_CLOSE,SOE_REMARK_NOR);
						}
						break;
						case VALVE_STATE_CLOSE_EMERGENCY:
						{
							SaveNewSoe(SOE_VALVE_CLOSE_EMERGENCY,SOE_REMARK_NOR);
						}
						break;
						case VALVE_STATE_CLOSE_LOCK:
						{
							SaveNewSoe(SOE_VALVE_CLOSE_LOCK,SOE_REMARK_NOR);
						}
						break;
					}
				}
                valve_deal_state = VALVE_DEAL_S0;
            }
        }
        break;

        case (VALVE_DEAL_ACTIVE_HALF):	//ڻ---뿪
        {
            if (ValveIfIdle())
            {
                ValveStartTask(VALVE_TO_HALF_OPEN);
                valve_deal_state = VALVE_DEAL_ACTIVE_OPEN;
            }
        }
        break;

        case (VALVE_DEAL_ACTIVE_OPEN):	//ڻ---ȫ
        {
            if (ValveIfIdle())
            {
                ValveStartTask(VALVE_TO_OPEN);
                valve_deal_state = VALVE_DEAL_S0;
            }
        }
        break;

        default:
        {
            valve_rcv_order = 0;
            valve_rcv_order_backup = 0;
            valve_deal_state = VALVE_DEAL_S0;
        }
        break;
    }
}
/*******************************************************************************
 * @fun_name:	ValveGetUploadStateApp
 * @brief   :   app ѯǷڹطϱڼ
 * @param[in] :	None
 * @param[out] :None
 * @retval     :None
 * @other     :
 ******************************************************************************/
u8 ValveGetUploadStateApp(void)
{
    if(s_valapp_upload_state == 1)
	{
		return VALVE_CLOSE_UPLOAD_TIME;
	}
	return NO_VALVE_CLOSE_UPLOAD_TIME;
}

//
void ValveDealAppStart(u8 valve_order)
{
    valve_rcv_order = valve_order;
}

//п
u8 ValveDealAppMachineIfIdle(void)
{
    if(VALVE_DEAL_S0 == valve_deal_state)
    {
        return TASK_IDLE;
    }
    else
    {
        return TASK_BUSY;
    }
}
/*******************************************************************************
 * @fun_name:	ValveGetStateApp
 * @brief   :   app stateѯ
 * @param[in] :	None
 * @param[out] :None
 * @retval     :None
 * @other     :
 ******************************************************************************/
u8 ValveGetStateApp(void)
{
    return ValveGetState();
}
#endif

#ifdef __cplusplus
}
#endif

/***************************************************************END OF FILE****/

